%
% MATLAB script for Rhapsody Parametric Constraints Evaluator
% xpceMATLABexecute.m
%
% (C) Copyright IBM Corp. 2010. All rights reserved.
%

while true
	xpceRequest = xpceServer.receiveRequest();
	if (length(xpceRequest) <= 0)
		break
	elseif xpceRequest == 'xpceQuit'
		xpceServer.finalizeServer();
		quit
	elseif xpceRequest.endsWith(';')
		try
			eval(xpceRequest);
		catch
			disp('    => eval error!')
		end
	elseif xpceRequest.endsWith(':')
		try
			evalin(symengine,char(xpceRequest));
		catch
			disp('    => evalin error!')
		end
	else
		try
			xpceAnswer = eval(xpceRequest);
			if (isnumeric(xpceAnswer) | islogical(xpceAnswer))
				xpceServer.sendResult(num2str(xpceAnswer));
			else
				xpceServer.sendResult(char(xpceAnswer));
			end
		catch
			xpceServer.sendResult('');
			disp('    => eval error!')
		end
	end
end